- name: configure hostname
  become: true
  when:
    - configure_etc_hostname is defined
    - configure_etc_hostname != None
    - configure_etc_hostname | length != 0
  ansible.builtin.hostname:
    name: "{{ configure_etc_hostname }}"

- name: configure inventory groups in /etc/hosts
  become: true
  when:
    - configure_etc_hosts_groups_ipv4_name is defined
    - configure_etc_hosts_groups_ipv4_name != None
    - configure_etc_hosts_groups_ipv4_name | length != 0
  block:
    - name: gather facts
      ansible.builtin.gather_facts:

    - name: configure inventory groups in /etc/hosts
      ansible.builtin.blockinfile:
        path: /etc/hosts
        marker: "# {mark} {{ ansible_managed | default('ANSIBLE MANAGED BLOCK') }}"
        block: |
          {% for group in configure_etc_hosts_groups_ipv4_name %}
          {% if groups[group] is defined %}
          ## {{ group }}
          {% for host in groups[group] %}
          {{ hostvars[host]['ansible_default_ipv4']['address'] }} {{ hostvars[host]['inventory_hostname_short'] }} {{ hostvars[host]['inventory_hostname'] }}
          {% endfor %}
          {% endif %}
          {% endfor %}
        state: "{{ configure_etc_hosts_groups_state | default('present') }}"

- name: configure /etc/hosts default ipv4 address record
  become: true
  when:
    - configure_etc_hosts_local_ipv4_name is defined
    - configure_etc_hosts_local_ipv4_name != None
    - configure_etc_hosts_local_ipv4_name | length != 0
  ansible.builtin.lineinfile:
    path: /etc/hosts
    regexp: "^{{ ansible_default_ipv4['address'] }}"
    line: "{{ ansible_default_ipv4['address'] }} {{ configure_etc_hosts_local_ipv4_name }}"
    state: "{{ configure_etc_hosts_local_state | default('present') }}"
